'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = deserializeRange;

var _evaluateXPath = require('./../xpath/evaluateXPath.js');

var _evaluateXPath2 = _interopRequireDefault(_evaluateXPath);

var _isText = require('./../utils/isText.js');

var _isText2 = _interopRequireDefault(_isText);

var _getWholeTextUpTo = require('./../utils/getWholeTextUpTo.js');

var _getWholeTextUpTo2 = _interopRequireDefault(_getWholeTextUpTo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {string} serializedRange
 * @returns {?Range} range
 */
function deserializeRange(serializedRange) {
  var json = JSON.parse(serializedRange);
  var so = json.startOffset;
  var sc = (0, _evaluateXPath2.default)(json.startContainer, so);
  var eo = json.endOffset;
  var ec = (0, _evaluateXPath2.default)(json.endContainer, eo);
  var range = document.createRange();

  try {
    range.setStart(sc, (0, _isText2.default)(sc) ? so - (0, _getWholeTextUpTo2.default)(sc).length : so);
    range.setEnd(ec, (0, _isText2.default)(ec) ? eo - (0, _getWholeTextUpTo2.default)(ec).length : eo);
  } catch (e) {
    return null;
  }

  return range;
}