'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findRange;

var _getTextNodeFromOffset = require('./../utils/getTextNodeFromOffset.js');

var _getTextNodeFromOffset2 = _interopRequireDefault(_getTextNodeFromOffset);

var _getNextTextNode = require('./../utils/getNextTextNode.js');

var _getNextTextNode2 = _interopRequireDefault(_getNextTextNode);

var _bodyIndexOf = require('./../utils/bodyIndexOf.js');

var _bodyIndexOf2 = _interopRequireDefault(_bodyIndexOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {string} searchValue
 * @param {number} [fromIndex]
 * @returns {?Range}
 */
function findRange(searchValue) {
  var fromIndex = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

  var index = document.body.textContent.indexOf(searchValue, fromIndex);

  if (index !== -1) {
    var startContainer = (0, _getTextNodeFromOffset2.default)((0, _getNextTextNode2.default)(document.body), index);
    var startOffset = index - (0, _bodyIndexOf2.default)(startContainer);
    var endContainer = (0, _getTextNodeFromOffset2.default)(startContainer, startOffset + searchValue.length, true);
    var endOffset = startContainer === endContainer ? startOffset + searchValue.length : (0, _bodyIndexOf2.default)(startContainer) + startOffset + searchValue.length - (0, _bodyIndexOf2.default)(endContainer);

    var range = document.createRange();
    range.setStart(startContainer, startOffset);
    range.setEnd(endContainer, endOffset);

    return range;
  }

  return null;
}