'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getRangeTextNodes;

var _isText = require('./../utils/isText.js');

var _isText2 = _interopRequireDefault(_isText);

var _rangeIntersectsNode = require('./rangeIntersectsNode.js');

var _rangeIntersectsNode2 = _interopRequireDefault(_rangeIntersectsNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Range} range
 * @returns {Text[]}
 */
function getRangeTextNodes(range) {
  var root = range.commonAncestorContainer;
  var textNodes = [];

  // if the common ancestor container is a text node then that's the only node in the range
  if ((0, _isText2.default)(root)) {
    textNodes.push(root);
    return textNodes;
  }

  var walker = document.createTreeWalker(root, NodeFilter.SHOW_TEXT, null, false);

  while (walker.nextNode()) {
    if ((0, _rangeIntersectsNode2.default)(range, walker.currentNode)) {
      textNodes.push(walker.currentNode);
    }
  }

  return textNodes;
}