'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = highlightRange;

var _splitRangeBoundaries = require('./splitRangeBoundaries.js');

var _splitRangeBoundaries2 = _interopRequireDefault(_splitRangeBoundaries);

var _getRangeTextNodes = require('./getRangeTextNodes.js');

var _getRangeTextNodes2 = _interopRequireDefault(_getRangeTextNodes);

var _wrap = require('./../utils/wrap.js');

var _wrap2 = _interopRequireDefault(_wrap);

var _constants = require('./../constants.js');

var _unfold = require('./../utils/unfold.js');

var _unfold2 = _interopRequireDefault(_unfold);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Range} range
 * @returns {HTMLElement[]}
 */
function highlightRange(range) {
  return (0, _getRangeTextNodes2.default)((0, _splitRangeBoundaries2.default)(range)).map(function (textNode) {
    return (0, _wrap2.default)(textNode, document.createElement(_constants.HIGHLIGHT_TAG));
  }).filter(function (wrapper) {
    // This fixes some formatting issues with table wrappers by getting rid of
    // highlights with no width and height or no text.
    if (wrapper.offsetWidth === 0 && wrapper.offsetHeight === 0 || !wrapper.textContent) {
      (0, _unfold2.default)(wrapper);
      return false;
    }

    return true;
  });
}