'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = serializeRange;

var _getXPath = require('./../xpath/getXPath.js');

var _getXPath2 = _interopRequireDefault(_getXPath);

var _isText = require('./../utils/isText.js');

var _isText2 = _interopRequireDefault(_isText);

var _getWholeTextUpTo = require('./../utils/getWholeTextUpTo.js');

var _getWholeTextUpTo2 = _interopRequireDefault(_getWholeTextUpTo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Range} range
 * @returns {string}
 */
function serializeRange(range) {
  var sc = range.startContainer;
  var so = range.startOffset;
  var ec = range.endContainer;
  var eo = range.endOffset;

  return JSON.stringify({
    startContainer: (0, _getXPath2.default)(sc),
    startOffset: (0, _isText2.default)(sc) ? (0, _getWholeTextUpTo2.default)(sc).length + so : so,
    endContainer: (0, _getXPath2.default)(ec),
    endOffset: (0, _isText2.default)(ec) ? (0, _getWholeTextUpTo2.default)(ec).length + eo : eo
  });
}