'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = splitRangeBoundaries;

var _isText = require('./../utils/isText.js');

var _isText2 = _interopRequireDefault(_isText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Range} range
 * @returns {Range}
 */
function splitRangeBoundaries(range) {
  if ((0, _isText2.default)(range.startContainer)) {
    if (range.startOffset > 0) {
      range.setStart(range.startContainer.splitText(range.startOffset), 0);
    }
  }

  if ((0, _isText2.default)(range.endContainer)) {
    if (range.endOffset < range.endContainer.length) {
      range.endContainer.splitText(range.endOffset);
    }
  }

  return range;
}