"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = bodyIndexOf;
/**
 * @param {Text} text
 * @returns {number}
 */
function bodyIndexOf(text) {
  var walker = document.createTreeWalker(document.body, NodeFilter.SHOW_TEXT, null, false);

  // count the length of all the text nodes before the input text
  var charCount = 0;
  while (walker.nextNode() && walker.currentNode !== text) {
    charCount += walker.currentNode.length;
  }

  return walker.currentNode === text ? charCount : -1;
}