"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getNextTextNode;
/**
 * @param {Node} node
 * @returns {?Text}
 */
function getNextTextNode(node) {
  var walker = document.createTreeWalker(document, NodeFilter.SHOW_ALL, null, false);

  // get the walker to the input node
  while (walker.currentNode !== node) {
    walker.nextNode();
  }

  // iterate the walker until a text node is found
  while (walker.nextNode() && walker.currentNode.nodeType !== Node.TEXT_NODE) {}

  return walker.currentNode.nodeType === Node.TEXT_NODE ? walker.currentNode : null;
}