'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getTextNodeFromOffset;

var _getNextTextNode = require('./getNextTextNode.js');

var _getNextTextNode2 = _interopRequireDefault(_getNextTextNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Text} text
 * @param {number} offset
 * @param {boolean} [inclusive]
 * @returns {?Text}
 */
function getTextNodeFromOffset(text, offset) {
  var inclusive = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  if (offset < 0) {
    return null;
  }

  if (offset === 0) {
    return text;
  }

  // count the length of all the text nodes until it gets to the offset.
  var charCount = 0;
  var current = text;
  while (current && (inclusive ? charCount < offset : charCount <= offset)) {
    charCount += current.textContent.length;

    if (inclusive ? charCount >= offset : charCount > offset) {
      return current;
    }

    current = (0, _getNextTextNode2.default)(current);
  }

  return null;
}