'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getWholeTextUpTo;

var _isTextLike = require('./isTextLike.js');

var _isTextLike2 = _interopRequireDefault(_isTextLike);

var _isHighlight = require('./isHighlight.js');

var _isHighlight2 = _interopRequireDefault(_isHighlight);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Text} node
 * @returns {string}
 */
function getWholeTextUpTo(node) {
  var current = node;
  var wholeText = '';

  // get the text from all the previous siblings
  while (current.previousSibling) {
    current = current.previousSibling;

    if ((0, _isTextLike2.default)(current)) {
      wholeText = current.textContent + wholeText;
    } else {
      return wholeText;
    }
  }

  // if there are no more previous siblings and the parent is a highlight then
  // there could be more text to consider...
  if (current.parentNode && (0, _isHighlight2.default)(current.parentNode)) {
    return getWholeTextUpTo(current.parentNode) + wholeText;
  }

  return wholeText;
}