'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = normalFind;

var _normalIndexMap = require('./normalIndexMap');

var _normalIndexMap2 = _interopRequireDefault(_normalIndexMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {string} source
 * @param {string} pattern
 * @param {number} [fromIndex]
 * @returns {?object}
 */
function normalFind(source, pattern) {
  var fromIndex = arguments.length <= 2 || arguments[2] === undefined ? 0 : arguments[2];

  var regex = /\s+/g;

  var normalize = function normalize(text) {
    return text.replace(regex, ' ');
  };

  var nSource = normalize(source);
  var nPattern = normalize(pattern);
  var nIndex = nSource.indexOf(nPattern, nSource.slice(0, fromIndex).replace(regex, ' ').length);

  if (nIndex !== -1) {
    var start = (0, _normalIndexMap2.default)(source, regex, nIndex);
    var end = (0, _normalIndexMap2.default)(source, regex, nIndex + nPattern.length);

    return {
      match: source.slice(start, end),
      start: start
    };
  }

  return null;
}