'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fuzzyIndexMap;
/**
 * @param {string} text
 * @param {RegExp} test
 * @param {number} normalIndex
 * @returns {number}
 */
function fuzzyIndexMap(text, test, normalIndex) {
  var buffer = text;
  var counter = normalIndex;
  var regex = new RegExp('^' + test.source);
  var actualIndex = 0;
  var match = undefined;

  while (buffer.length !== 0 && counter--) {
    match = buffer.match(regex);
    if (match && match[0]) {
      actualIndex += match[0].length;
      buffer = buffer.replace(regex, '');
    } else {
      actualIndex++;
      buffer = buffer.slice(1);
    }
  }

  return actualIndex;
}