'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getXPath;

var _isHighlight = require('./../utils/isHighlight.js');

var _isHighlight2 = _interopRequireDefault(_isHighlight);

var _getXPathName = require('./getXPathName.js');

var _getXPathName2 = _interopRequireDefault(_getXPathName);

var _getXPathIndex = require('./getXPathIndex.js');

var _getXPathIndex2 = _interopRequireDefault(_getXPathIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Node} node
 * @returns {string}
 */
function getXPath(node) {
  // highlights don't have an XPath because they weren't there in the first place!
  if ((0, _isHighlight2.default)(node)) {
    return '';
  }

  var current = node;
  var absolutePath = '';
  var idPath = '';

  // look at each parent node, get it's sibling index and form the path
  while (current.parentNode) {
    // shortcut for when an id is found
    if (!idPath && current.id) {
      idPath = '//*[@id="' + node.id + '"]' + absolutePath + '|';
    }

    if (!(0, _isHighlight2.default)(current)) {
      absolutePath = '/' + (0, _getXPathName2.default)(current) + '[' + (0, _getXPathIndex2.default)(current) + ']' + absolutePath;
    }

    current = current.parentNode;
  }

  return idPath + absolutePath;
}