'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getXPathIndex;

var _getXPathName = require('./getXPathName.js');

var _getXPathName2 = _interopRequireDefault(_getXPathName);

var _isTextLike = require('./../utils/isTextLike.js');

var _isTextLike2 = _interopRequireDefault(_isTextLike);

var _isHighlight = require('./../utils/isHighlight.js');

var _isHighlight2 = _interopRequireDefault(_isHighlight);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Node} node
 * @returns {number}
 */
function getXPathIndex(node) {
  var current = node;
  var index = 0;

  // count all previous siblings that have the same XPath name as the input node
  while (current) {
    // if the current node is text like then ignore it if the sibling in the
    // next iteration of the loop is also text like
    if ((0, _getXPathName2.default)(current) === (0, _getXPathName2.default)(node) && !((0, _isTextLike2.default)(current) && current.previousSibling && (0, _isTextLike2.default)(current.previousSibling))) {
      index++;
    }

    current = current.previousSibling;
  }

  // if the parent of the input node is a highlight then there is more to it...
  if (node.parentNode && (0, _isHighlight2.default)(node.parentNode)) {
    return index + getXPathIndex(node.parentNode) - 1;
  }

  return index;
}