'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fuzzyStringSearch;

var _diffMatchPatch = require('diff-match-patch');

var _diffMatchPatch2 = _interopRequireDefault(_diffMatchPatch);

var _constants = require('./../constants.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {string} source
 * @param {string} pattern
 * @param {number} location
 * @param {boolean} [word]
 * @returns {object}
 */
function fuzzyStringSearch(source, pattern, location) {
  var word = arguments.length <= 3 || arguments[3] === undefined ? true : arguments[3];

  var dmp = new _diffMatchPatch2.default();

  dmp.Match_Threshold = _constants.DMP_THRESHOLD;
  dmp.Match_Distance = _constants.DMP_DISTANCE;
  dmp.Match_MaxBits = pattern.length;

  var start = dmp.match_main(source, pattern, location);
  if (start !== -1) {
    var end = start + pattern.length;
    return {
      match: word ? source.slice(start, end + source.slice(end).search(/\s/)) : source.slice(start, end),
      start: start
    };
  }

  return null;
}